#!/usr/bin/python
# -*- coding: utf-8 -*-
##      config.py
##
##
## Copyright (C) 2007-2008-2008 Max V. Stotsky <ms@pereslavl.ru>
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 3 or later.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##

import re
import string
from functools import partial

def readconfig(filename, options):
	"""
	This function reads the configuration file and fills the options
	dictionary. The configuration file have lines:
		option_name option_value
	"""
	f = None
	try :
		f = open(filename, "r")
		for strg in f :
			i = 0
			m = re.search("^(.*?) (.*)\n$", strg)
			if m and (m.group(1) in options) :
				if isinstance(options[m.group(1)], bool) :
					conv = string2bool
				elif isinstance(options[m.group(1)], list) :
					conv = partial(string.split, sep=" ")
				else :
					conv = type(options[m.group(1)])
				options[m.group(1)] = conv(m.group(2))

	except :
		print "Can't read %s" % filename
		return False
	finally :
		if f : f.close()
	return True

def saveconfig(filename, options) :
	"""
	This function writes the options dictionary to the configuration file.
	"""
	f = None
	try :
		f = open(filename, "w")
		for opt_key in options :
			val = options[opt_key]
			sval = ""
			if isinstance(val, str) :
				sval = val
			elif isinstance(val, list) :
				sval = string.join(val)
			else :
				sval = `val`
			f.write(opt_key + " " + sval + "\n")
	except :
		print "Can't write %s" % filename
		return False
	finally :
		if f : f.close()
	return True

def string2bool(strg) :
	if isinstance(strg, bool) :
		return strg
	if strg == "True" :
		return True
	return False

