#!/usr/bin/python
# -*- coding: utf-8 -*-
##      gnetworktester.py
##
##
## Copyright (C) 2008 Max V. Stotsky <ms@pereslavl.ru>
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 3 or later.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##

import getopt
import gettext
import gtk
import os
import sys

import autoconfiggui
import globs
import speedtestnetgui
import tester
import testing
import trayicon
import work_table
from pref import preferences

_ = gettext.gettext

def run_tester():
	"""
	This function runs main program interface.
	"""
	pbuf = gtk.gdk.pixbuf_new_from_file(preferences.opt["app_icon"])
	gtk.window_set_default_icon_list(pbuf)

	globs.autoconfiggui = autoconfiggui.AutoProgressBar()
	globs.testing = testing.Testing()
	globs.worktable = work_table.WorkTable()
	globs.testergui = tester.TesterGui()
	globs.trayicon = trayicon.TrayIcon()

	work_area_widget = globs.testergui.glade_main_window.get_widget("work_area")
	globs.worktable.set_table_widget(work_area_widget)

	globs.speedtestnetgui = speedtestnetgui.SpeedTestNetGui()

	if os.name != 'nt' :
		gtk.gdk.threads_init()

	gtk.main()
	sys.exit(0)

def main(argv):
	try:
		opts, args = getopt.getopt(argv[1:], "hdv", ["help", "debug", "version"])
	except getopt.error, msg:
		print msg
		print _("for help use --help")
		sys.exit(42)
	for o, a in opts:
		if o in ("-h", "--help"):
			print preferences.const["app_name"] + " [-h] [--help]"
			print
			print "  -h, --help		 " + _("show this message")
			print "  -d, --debug		" + _("enable debug mode")
			print "  -v, --version	  " + _("display version and quit")
			print
			print _("Report bugs to <%s>.") % preferences.const["app_email"]
			sys.exit()
		elif o in ("-d", "--debug"):
			preferences.var["debug"] = True
		elif o in ("-v", "--version"):
			print "%s %s" % (preferences.const["app_name"], preferences.const["app_version"])
			sys.exit(0)
	del opts
	del args

	run_tester()

if __name__ == "__main__":
	main(sys.argv)

