#!/usr/bin/python
# -*- coding: utf-8 -*-
##      googlemap.py
##
##
## Copyright (C) 2010 Max V. Stotsky <ms@pereslavl.ru>
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 3 or later.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##

import debug
import open_with
import re
from pref import preferences

class GMap(debug.Debug) :
	def __init__(self, hosts) :
		debug.Debug.__init__(self)
		self.hosts = hosts

	def prepare(self) :
		"""
		This function builds google maps url.
		"""
		self.url = preferences.opt["googlemap_url"]
		for host in self.hosts :
			if not (host.ip.startswith("127.") or     # not a localhost IP addresses
					host.ip == "::1" or
					host.ip == "0:0:0:0:0:0:0:1" or
					host.ip.startswith("192.168.") or # not a private IP addresses
					host.ip.startswith("10.") or
					re.match("172\.(1[6789]|2\d|3[01])\.", host.ip) or
					host.ip.startswith("fc00")
					) :
				self.url += "marker=%s==%s==%.2f&" %\
						(host.ip, host.hostname, host.cmsavg())

	def run(self) :
		"""
		This function opens google maps url.
		"""
		self.prepare()
		if self.url != preferences.opt["googlemap_url"] :
			open_with.open_link(self.url, preferences.var["open_browser"])
			return True

		return False
