#!/usr/bin/python
# -*- coding: utf-8 -*-
##      restore.py
##
##
## Copyright (C) 2008 Max V. Stotsky <ms@pereslavl.ru>
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 3 or later.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##

import gettext
import gtk

import autoconfiggui
import debug
import gui_funcs

_ = gettext.gettext

class RestoreHosts(debug.Debug) :
	def __init__(self) :
		debug.Debug.__init__(self)

	def open_list(self, window=None) :
		"""
		This function opens and adds a list of hosts to the main table.
		"""
		filename = gui_funcs.show_filechooser_dialog(window,
				_("Open host's list..."), "open")

		if filename == "" :
			return ""

		a = autoconfiggui.AutoProgressBar()
		a.run(window, filename, False)
		if a.canceled : return ""

		return filename

	def save_list(self, hosts, filename="", window=None) :
		"""
		This function saves a list of hosts to a file.
		"""
		if filename == "" :
			filename = gui_funcs.show_filechooser_dialog(window,
					_("Save host's list..."), "save")

		if filename == "" :
			return ""

		try :
			f = open(filename, "w")
			for h in hosts :
				f.write(str(h) + "\n")
			f.close()
		except :
			gui_funcs.show_message(None, gtk.MESSAGE_WARNING,
				_("Error!"), _("Can't write %s") % filename)
		finally :
			f.close()

		return filename
